#ifndef ANIMATION_H
#define ANIMATION_H

// Defines each of the various animation events that can occur.
enum animation_event {
	ANIMATION_EVENT_NONE,
	ANIMATION_EVENT_RESET,
	ANIMATION_EVENT_TIMER_A,
	ANIMATION_EVENT_TIMER_B,
	ANIMATION_EVENT_TIMER_C,
	ANIMATION_EVENT_TIMER_D,
};

// Defines each of the various animation types that are available.
enum animation_type {
	ANIMATION_TYPE_SIN_FAST,
	ANIMATION_TYPE_SIN_SLOW,
	ANIMATION_TYPE_CHASER,
	ANIMATION_TYPE_RANDOM_FADE,
	ANIMATION_TYPE_RANDOM_FLASH,
	ANIMATION_COUNT,
};

// Defines each of the timers available for animation.
enum animation_timer {
	ANIMATION_TIMER_A,
	ANIMATION_TIMER_B,
	ANIMATION_TIMER_C,
	ANIMATION_TIMER_D,
};

// Gets or sets the current animation type.
extern enum animation_type animation_type;

// Initialise the animations.
void animation_init(void);

// Run the animations for one tick.
void animation_tick(void);

// Advance to the next animation.
void animation_next_type(void);

// Switch to a random animation.
void animation_random_type(void);

#endif